'\" t
.TH "" 3 "" "Version 3.0" "Free Widget Foundation"
.SH NAME
CheckBox
.SH DESCRIPTION
The \fICheckBox\fP widget contains a text label and a rectangular box
that is either unchecked (empty) or checked (contains an x). The current
state of the checkbox can be obtained by querying the \fIstate\fP resource.





.SS "Public variables"

.ps -2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
CheckBox
Name	Class	Type	Default
XtNlabel	XtCLabel	String 	NULL 
XtNfont	XtCFont	FontStruct	XtDefaultFont 
XtNcolor	XtCColor	Pixel 	XtDefaultForeground 
XtNinternalOffset	XtCInternalOffset	Dimension 	2 
XtNboxSize	XtCBoxSize	Dimension 	11 
XtNboxGap	XtCBoxGap	Dimension 	9 
XtNstate	XtCState	Boolean 	False 

.TE
.ps +2


.TP
.I "XtNlabel"
The text to be displayed

	




.TP
.I "XtNfont"
The text is drawn using the font given in the \fIfont\fP resources.

	




.TP
.I "XtNcolor"
The \fIcolor\fP resource specifies the color used for drawing the text.

	




.TP
.I "XtNinternalOffset"
The offset from the text to the outside edge of the widgets window.

        




.TP
.I "XtNboxSize"
The size of the checkbox.

        




.TP
.I "XtNboxGap"
The number of pixels between the checkbox and the text.

        




.TP
.I "XtNstate"
The state of the checkbox. True means on, False means off.

        




.TP
.I "XtNborder_width"
The \fIborder_width\fP by default is 0.

        








.ps -2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
Core
Name	Class	Type	Default
XtNx	XtCX	Position 	0 
XtNy	XtCY	Position 	0 
XtNwidth	XtCWidth	Dimension 	0 
XtNheight	XtCHeight	Dimension 	0 
borderWidth	XtCBorderWidth	Dimension 	0 
XtNcolormap	XtCColormap	Colormap 	NULL 
XtNdepth	XtCDepth	Int 	0 
destroyCallback	XtCDestroyCallback	XTCallbackList 	NULL 
XtNsensitive	XtCSensitive	Boolean 	True 
XtNtm	XtCTm	XTTMRec 	NULL 
ancestorSensitive	XtCAncestorSensitive	Boolean 	False 
accelerators	XtCAccelerators	XTTranslations 	NULL 
borderColor	XtCBorderColor	Pixel 	0 
borderPixmap	XtCBorderPixmap	Pixmap 	NULL 
background	XtCBackground	Pixel 	0 
backgroundPixmap	XtCBackgroundPixmap	Pixmap 	NULL 
mappedWhenManaged	XtCMappedWhenManaged	Boolean 	True 
XtNscreen	XtCScreen	Screen *	NULL 

.TE
.ps +2

.SS "Translations"

The \fItoggle\fP action toggles the widget between `on' and `off'. By
default it is bound to a click of the left mouse button as well as to
the Space key.

        


.nf
<Btn1Down>,<Btn1Up>: toggle() 
.fi



.nf
<Key>space: toggle() 
.fi


.SS "Actions"


.TP
.I "toggle

The \fItoggle\fP action switches the state of the checkbox.





