'\" t
.TH "" 3 "" "Version 3.0" "Free Widget Foundation"
.SH NAME
LinkText
.SH DESCRIPTION
The \fILinkText\fP widget is used to display text in multiple fonts
and colors and to provide hyperlinks.  For correct operation, it should
be used only as a child of the accompanying \fILinkView\fP widget, which
provides a scrolling viewport.  This widget also requires the dynamically
growable buffer routines in the file \fIbuffer.c\fP.





.SS "Public variables"

.ps -2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
LinkText
Name	Class	Type	Default
XtNhypertext	XtCHypertext	String 	NULL 
XtNactivate	XtCActivate	Callback	NULL 
XtNnewpage	XtCNewpage	Callback	NULL 
XtNinternalOffset	XtCInternalOffset	Dimension 	4 
XtNfont1	XtCFont1	FontStruct	XtDefaultFont 
XtNfont2	XtCFont2	FontStruct	XtDefaultFont 
XtNfont3	XtCFont3	FontStruct	XtDefaultFont 
XtNfont4	XtCFont4	FontStruct	XtDefaultFont 
XtNfont5	XtCFont5	FontStruct	XtDefaultFont 
XtNcolor1	XtCColor1	Pixel 	XtDefaultForeground 
XtNcolor2	XtCColor2	Pixel 	XtDefaultForeground 
XtNcolor3	XtCColor3	Pixel 	XtDefaultForeground 
XtNcolor4	XtCColor4	Pixel 	XtDefaultForeground 
XtNcolor5	XtCColor5	Pixel 	XtDefaultForeground 
XtNcolor6	XtCColor6	Pixel 	XtDefaultForeground 
XtNcolor7	XtCColor7	Pixel 	XtDefaultForeground 
XtNcolor8	XtCColor8	Pixel 	XtDefaultForeground 
XtNlinkColor	XtCLinkColor	Pixel 	"mediumblue"
XtNselectForeground	XtCSelectForeground	Pixel 	XtDefaultBackground 
XtNselectBackground	XtCSelectBackground	Pixel 	XtDefaultForeground 
XtNunderlineLinks	XtCUnderlineLinks	Boolean 	True 
XtNnormalCursor	XtCNormalCursor	Cursor 	"top_left_arrow"
XtNlinkCursor	XtCLinkCursor	Cursor 	"hand2"
XtNbusyCursor	XtCBusyCursor	Cursor 	"watch"
XtNselectThreshold	XtCSelectThreshold	int 	5 
XtNspaceWidth	XtCSpaceWidth	int 	5 
XtNindentAscii	XtCIndentAscii	Boolean 	True 
XtNbulletDiameter	XtCBulletDiameter	int 	7 
XtNscrollInterval	XtCScrollInterval	int 	80 

.TE
.ps +2


.TP
.I "XtNhypertext"
The \fIhypertext\fP resource contains the string that is to be displayed.  
The text may include various formatting tags
which are contained within '\fI<\fP' and '\fI>\fP' characters.

Font changes are indicated by "\fI<f?>\fP" where \fI?\fP is a font number from 1 to 5.
The specified font will apply to all text up to the next font change.

Color changes are indicated by "\fI<c?>\fP" where ? is a color number from
1 to 8.
The specified color will apply to all text up to the next color change.

A hyperlink is indicated by a string of the form "\fI<l tag-text>link-text<e>\fP".
The \fIlink-text\fP is the text that will appear to the user, highlighted and 
underlined. The \fItag-text\fP is a string that will be passed to a 
client's \fIactivate\fP callback procedure when the hypertext is clicked.

A dotted tab is a line of dots that extends across the page to a specified
pixel position. It is indicated by "\fI<d nnn>\fP" where \fInnn\fP is  a decimal number
specifying the desired pixel position.  If the end position of the dotted tab
is before the current text position, the dotted tab will be placed on the
following line.

A "\fI<w1>\fP" tag will cause subsequent text to be wrapped to the width of the
parent viewport widget. Wrapping can be disabled (the default state) with
a "\fI<w0>\fP" tag.

A "\fI<m1>\fP" tag will cause subsequent text to be horizontally centered. 
Centering can be disabled (the default state) with
a "\fI<m0>\fP" tag.

Text can be indented by a specified number of pixels with a "\fI<i nnn>\fP" tag,
where \fInnn\fP is  a decimal number
specifying the desired pixel indent.  The indent level remains in effect
until it is explicitly changed, or until a bulleted 
or hanging paragraph is encountered.

A hanging paragraph is where all lines except the first are indented by a
certain number of pixels. A hanging paragraph is indicated by starting the 
paragraph with a "\fI<h nnn>\fP" tag, where \fInnn\fP is the number of pixels to
indent. When the paragraph ends (a newline is encountered) the indentation
value is reset to zero.

A bulleted paragraph is indicated by starting the paragraph with a "\fI<b>\fP" tag.
The first line of the paragraph will be preceded by a bullet, and subsequent
lines will be indented by the width of the bullet.


	




.TP
.I "XtNactivate"
The \fIactivate\fP callback is called when the user clicks on a link. A pointer
to a \fILinkRecord\fP is passed.

	




.TP
.I "XtNnewpage"
The \fInewpage\fP callback is called whenever a new page is is first displayed,
either through calling \fILinkTextNextPage\fP, \fILinkTextPrevPage\fP, 
\fILinkTextSetPage\fP, or by setting new hypertext.  A pointer to a 
\fIPageRecord\fP is passed which contains the current page and the total number
of pages. The principal use for this
callback is to enable the display of the current page number by a separate
widget.

	




.TP
.I "XtNinternalOffset"
The offset from the text to the outside edge of the widgets window.

	




.TP
.I "XtNfont1"
The text is drawn using the fonts given in the \fIfont1-5\fP resources. 
The particular font to be used for rendering text 
is specified by font change tags within the
hypertext string.

	




.TP
.I "XtNfont2"



.TP
.I "XtNfont3"



.TP
.I "XtNfont4"



.TP
.I "XtNfont5"



.TP
.I "XtNcolor1"
The \fIcolor1-8\fP resources specify the colors used for drawing the text.
The particular color to be used for rendering text
is specified by color change tags within the
hypertext string.

	




.TP
.I "XtNcolor2"



.TP
.I "XtNcolor3"



.TP
.I "XtNcolor4"



.TP
.I "XtNcolor5"



.TP
.I "XtNcolor6"



.TP
.I "XtNcolor7"



.TP
.I "XtNcolor8"



.TP
.I "XtNlinkColor"
The \fIlinkColor\fP resource specifies the color used for drawing hyperlinks.

	




.TP
.I "XtNselectForeground"
The \fIselectForeground\fP and \fIselectBackground\fP resources specify the colors 
used for drawing selected text.

	




.TP
.I "XtNselectBackground"



.TP
.I "XtNunderlineLinks"
Specifies whether hyperlinks should be underlined or not.

	




.TP
.I "XtNnormalCursor"
The \fInormalCursor\fP resource specifies the cursor when not on a link.

	




.TP
.I "XtNlinkCursor"
The \fIlinkCursor\fP resource specifies the cursor when on a link.

	




.TP
.I "XtNbusyCursor"
The \fIbusyCursor\fP resource specifies the cursor to be displayed when the 
widget gets told (via the \fISetBusy\fP call) that the application is busy.

	




.TP
.I "XtNselectThreshold"
The \fIselectThreshold\fP resource specifies how many pixels the mouse cursor
must be moved before text selection is activated.

	




.TP
.I "XtNspaceWidth"
The \fIspaceWidth\fP resource is used when converting a text selection into
ASCII text.  For a dotted tab, the pixel measurement is converted to a
number of spaces by dividing by this resource.

	




.TP
.I "XtNindentAscii"
The \fIindentAscii\fP resource is used when converting a text selection into
ASCII text.  If set to true (the default) then if the text to be converted
contains a mixture of heading and non-heading lines, then the non-heading
lines will be indented by two spaces in order to make the headings stand out.
If set to false, then no lines will be indented.

	




.TP
.I "XtNbulletDiameter"
How big a bullet in a bulleted list should be.

	




.TP
.I "XtNscrollInterval"
How often (in milliseconds) the display will scroll by a line 
when selecting text and the mouse pointer is above or below the viewport.

	



.ps -2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
Composite
Name	Class	Type	Default
XtNchildren	XtCChildren	WidgetList 	NULL 
insertPosition	XtCInsertPosition	XTOrderProc 	NULL 
numChildren	XtCNumChildren	Cardinal 	0 

.TE
.ps +2

.ps -2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
Core
Name	Class	Type	Default
XtNx	XtCX	Position 	0 
XtNy	XtCY	Position 	0 
XtNwidth	XtCWidth	Dimension 	0 
XtNheight	XtCHeight	Dimension 	0 
borderWidth	XtCBorderWidth	Dimension 	0 
XtNcolormap	XtCColormap	Colormap 	NULL 
XtNdepth	XtCDepth	Int 	0 
destroyCallback	XtCDestroyCallback	XTCallbackList 	NULL 
XtNsensitive	XtCSensitive	Boolean 	True 
XtNtm	XtCTm	XTTMRec 	NULL 
ancestorSensitive	XtCAncestorSensitive	Boolean 	False 
accelerators	XtCAccelerators	XTTranslations 	NULL 
borderColor	XtCBorderColor	Pixel 	0 
borderPixmap	XtCBorderPixmap	Pixmap 	NULL 
background	XtCBackground	Pixel 	0 
backgroundPixmap	XtCBackgroundPixmap	Pixmap 	NULL 
mappedWhenManaged	XtCMappedWhenManaged	Boolean 	True 
XtNscreen	XtCScreen	Screen *	NULL 

.TE
.ps +2

.SS "Exports"

The \fILinkRecord\fP structure is passed to the clients \fIactivate\fP callback 
procedure when a hyperlink is clicked on.  The \fItext\fP is a string of the text 
actually displayed, \fIlink\fP is the tag text associated with the hyperlink.

	


.nf

.B type
 LinkRecord = struct _linkRecord {
                String                text;
                String                link;
                }
.fi



.nf

.B type
 PageRecord = struct _pageRecord {
                int                current;
                int                total;
                }
.fi


The \fIHypertextToText\fP procedure returns a pointer to a memory block 
containing an ASCII text version of the hypertext
currently displayed by the widget. 




.nf
char * HypertextToText( $)
.fi


The \fISetBusy\fP procedure takes one boolean argument. If it is true, then the widget
will display the \fIbusyCursor\fP, otherwise it will display the \fInormalCursor\fP
or \fIlinkCursor\fP as appropriate.




.nf
SetBusy( $, Boolean  v)
.fi


The \fIGetBaselineskip\fP procedure returns number of pixels between lines of text.  
The procedure could be really tricky, but at the moment it simply
assumes that \fIfont1\fP is the dominant text and returns the baselineskip 
for that font.




.nf
Dimension  GetBaselineskip( $)
.fi


When a display consists of more than one page, display the first page.




.nf
LinkTextFirstPage( $, Boolean  reset_to_top)
.fi


When a display consists of more than one page, display the last page.




.nf
LinkTextLastPage( $, Boolean  reset_to_top)
.fi


When a display consists of more than one page, display the next page
if it exists.




.nf
LinkTextNextPage( $, Boolean  reset_to_top)
.fi


When a display consists of more than one page, display the previous page
if it exists.




.nf
LinkTextPrevPage( $, Boolean  reset_to_top)
.fi


When a display consists of more than one page, display the specified page
if it exists.




.nf
LinkTextSetPage( $, int  p, Boolean  reset_to_top)
.fi


.SS "Translations"

The following translations allow the page to be grabbed and moved around
inside the parents viewport.

		


.nf
<Btn2Down>: grabpage() 
.fi



.nf
<Btn2Motion>: movepage() 
.fi



.nf
<Btn2Up>: releasepage() 
.fi



.nf
<Btn1Up>: chaselink() end_selection() 
.fi



.nf
<Btn1Down>: start_selection() 
.fi



.nf
<Btn1Motion>: move_selection() 
.fi



.nf
<Btn3Down>: extend_selection() 
.fi


The \fIcursortype\fP action sets the cursor to either the \fIlinkCursor\fP or the 
\fInormalCursor\fP, depending on whether the mouse pointer is over a hyperlink.

        


.nf
<Motion>: cursortype() 
.fi


.SS "Actions"


.TP
.I "chaselink

the \fIchaselink\fP action invokes the \fIactivate\fP callback if the mouse pointer
is over a hyperlink and text selection is not in progress.






.TP
.I "grabpage

The \fIgrabpage\fP action causes the mouse cursor to change into a hand shape.
Subsequent mouse movements will allow the screen to be scrolled via the
\fImovepage\fP action.






.TP
.I "movepage

The \fImovepage\fP action causes the display to be scrolled within the
parent viewport in response to mouse movements.






.TP
.I "releasepage

The \fIreleasepage\fP action performs various cleanup operations needed
after the display has been scrolled via the \fImovepage\fP action.







.TP
.I "cursortype

The \fIcursortype\fP action sets the cursor to \fInormalCursor\fP or \fIlinkCursor\fP
depending on whether the mouse pointer is over a hyperlink.






.TP
.I "start_selection

Start text selection. (Usually bound to mouse button 1.)






.TP
.I "move_selection

Drag out the text selection. (Usually bound to motion while mouse button 1
is held down.






.TP
.I "extend_selection

Extend the text selection. (Usually bound to mouse button 3.)






.TP
.I "end_selection

Finish making a text selection with the mouse.





