'\" t
.TH "" 3 "" "Version 3.0" "Free Widget Foundation"
.SH NAME
RadioBtn
.SH DESCRIPTION
The \fIRadioBtn\fP widget contains a number of text labels each adjacent to a
radio push button.  Only one button at a time can be selected.





.SS "Public variables"

.ps -2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
RadioBtn
Name	Class	Type	Default
XtNbuttons	XtCButtons	String 	NULL 
XtNfont	XtCFont	FontStruct	XtDefaultFont 
XtNcolor	XtCColor	Pixel 	XtDefaultForeground 
XtNinternalOffset	XtCInternalOffset	Dimension 	2 
XtNcircleSize	XtCCircleSize	Dimension 	11 
XtNcircleGap	XtCCircleGap	Dimension 	9 
XtNverticalGap	XtCVerticalGap	Dimension 	9 
XtNselected	XtCSelected	int 	0 
XtNradioCallback	XtCRadioCallback	Callback	NULL 

.TE
.ps +2


.TP
.I "XtNbuttons"
The text for all the radio buttons are specifed by the \fIbuttons\fP 
string resource.  The text for separate buttons is delimited by a 
vertical bar.

	




.TP
.I "XtNfont"
The text is drawn using the font given in the \fIfont\fP resource.

	




.TP
.I "XtNcolor"
The \fIcolor\fP resource specifies the color used for drawing the text.

	




.TP
.I "XtNinternalOffset"
The offset from the text to the outside edge of the widgets window.

        




.TP
.I "XtNcircleSize"
The size of each radio button.

        




.TP
.I "XtNcircleGap"
The number of pixels between the radio button and the text.

        




.TP
.I "XtNverticalGap"
The number of pixels between each button.

        




.TP
.I "XtNselected"
Which button is selected.

        




.TP
.I "XtNradioCallback"
The \fIradioCallback\fP is called from the \fIpress\fP action if a different
button was selected. The \fIcall_data\fP argument will be an integer indicating
the new selection.

	




.TP
.I "XtNborder_width"
The border width is 0 by default.

        



.ps -2
.TS
center box;
cBsss
lB|lB|lB|lB
l|l|l|l.
Core
Name	Class	Type	Default
XtNx	XtCX	Position 	0 
XtNy	XtCY	Position 	0 
XtNwidth	XtCWidth	Dimension 	0 
XtNheight	XtCHeight	Dimension 	0 
borderWidth	XtCBorderWidth	Dimension 	0 
XtNcolormap	XtCColormap	Colormap 	NULL 
XtNdepth	XtCDepth	Int 	0 
destroyCallback	XtCDestroyCallback	XTCallbackList 	NULL 
XtNsensitive	XtCSensitive	Boolean 	True 
XtNtm	XtCTm	XTTMRec 	NULL 
ancestorSensitive	XtCAncestorSensitive	Boolean 	False 
accelerators	XtCAccelerators	XTTranslations 	NULL 
borderColor	XtCBorderColor	Pixel 	0 
borderPixmap	XtCBorderPixmap	Pixmap 	NULL 
background	XtCBackground	Pixel 	0 
backgroundPixmap	XtCBackgroundPixmap	Pixmap 	NULL 
mappedWhenManaged	XtCMappedWhenManaged	Boolean 	True 
XtNscreen	XtCScreen	Screen *	NULL 

.TE
.ps +2

.SS "Translations"

The \fIpress\fP action selects the button underneath the mouse cursor. By
default it is bound to a click of the left mouse button.

        


.nf
<Btn1Down>,<Btn1Up>: press() 
.fi


.SS "Actions"


.TP
.I "press

The \fIpress\fP action selects the radio button under the mouse cursor. 





